(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)





Unprotect[Line]; ClearAll[Line]

Line[p_:0,v_][t_] := p + t v




ClearAll[Plane]

Plane[p_:0,v_,w_][{t_,s_}] := p + t v + s w




Unprotect[Circle]; ClearAll[Circle]

Circle[c:{cx_,cy_}:{0,0},r_][t_] := {cx + r Cos[t],cy + r Sin[t]}

Circle[c:{_,_,_},b:{_,_},r_][t_] := 
  Translate3D[c][Rotate3D[X,b][{0,r Cos[t],r Sin[t]}]];
  



ClearAll[Sphere]

Sphere[c:{cx_,cy_,cz_}:{0,0,0},r_][{t_,s_}] := 
  {cx + r Cos[s] Cos[t],cy + r Cos[s] Sin[t],cz + r Sin[s]}




ClearAll[Ellipse,Hyperbola,Parabola]

Ellipse[a_,b_][t_] := {a Cos[t],b Sin[t]}
Hyperbola[a_,b_][t_] := {a Cosh[t],b Sinh[t]}
Parabola[a_][t_] := {a t,t^2}




ClearAll[Ellipsoid,Hyperboloid,Paraboloid]

Ellipsoid[a_,b_,c_][{t_,s_}] := 
  {a Cos[t] Cos[s],b Sin[t] Cos[s],c Sin[s]}
  
Hyperboloid[a_,b_,c_,Elliptic][{t_,s_}] :=
  {a Cos[t] Sinh[s],b Sin[t] Sinh[s],c Cosh[s]}
Hyperboloid[a_,b_,c_,Hyperbolic][{t_,s_}] := 
  {a Cos[t] Cosh[s],b Sin[t] Cosh[s],c Sinh[s]}

Paraboloid[a_,b_,Elliptic][{t_,s_}] := 
  {a Cos[t] s,b Sin[t] s,s^2}
Paraboloid[a_,b_,Hyperbolic][{t_,s_}] := 
  {a Cos[t] s,b Sin[t] s,Cos[2t] s^2}




ClearAll[ConicalSurface,CylindricalSurface,RuledSurface]

ConicalSurface[cur_,v_:{0,0,0}][{t_,s_}] := (s - 1) v + s cur[t]
CylindricalSurface[cur_,v_:{0,0,1}][{t_,s_}] := cur[t] + s v
RuledSurface[cur_,v_][{t_,s_}] := cur[t] + s v[t]




ClearAll[RevolutionSurface]

RevolutionSurface[cur_,axis:__:Z][{t_,s_}] := Rotate3D[axis,t][cur[s]]




ClearAll[Bernstein,Bezier]
Options[Bezier] = {EndConditions -> None};

Bernstein[n_Integer,0][t_] := (1 - t)^n
Bernstein[n_Integer,n_][t_] := t^n

Bernstein[n_Integer,i_Integer][t_] := Binomial[n,i] (1 - t)^(n - i) t^i

Bezier[x:{_,__}][t_] := 
  Module[{n = Length[x] - 1},Sum[Bernstein[n,i][t] x[[i+1]],{i,0,n}]]

Bezier[n_Integer,x:{_,_,__},opts___?OptionQ][t_] :=
  Module[{l = Length[x],
          ends = EndConditions /. Flatten[{opts,Options[Bezier]}]},
    Switch[ends,
      Open,
        Bezier[n,Join[{2 x[[1]] - x[[2]]},x[[Range[2,l-1]]],
                      {2 x[[l]] - x[[l-1]]}],EndConditions -> None][t],
      Closed,
        If[Not[IntegerQ[(l - 1)/(n - 1)]],
           Message[Bezier::ptscl,l,n - 1];
             HoldForm[Bezier[n,x,opts][t]],
           Bezier[n,Append[x,x[[2]]],EndConditions -> None][t]],
      None, 
        Module[{m := (l - 2)/(n - 1)},
          If[Not[IntegerQ[m]],
             Message[Bezier::pts,l,n - 1];
               HoldForm[Bezier[n,x,opts][t]],
             WhichTable[(i - 1)/m <= t <= i/m, 
               Module[{j = (i - 1)(n - 1) + 1,s = m t - i + 1},
                 Bezier[Join[{(x[[j]] + x[[j+1]])/2},
                        x[[Range[j+1,j+n-1]]],
                        {(x[[j+n-1]] + x[[j+n]])/2}]][s]],{i,m},
                        DefaultValue -> {}]]]]]
                                            
Bezier::pts = "`1` control points; `2` k + 2 are exprected";
Bezier::ptscl = "`1` control points; `2` k + 1 are exprected";




ClearAll[BezierSurface]

Options[BezierSurface] = {EndConditions -> None};

BezierSurface[x_List][{t_,s_}] := Bezier[Map[Bezier[#][s]&,x]][t]

BezierSurface[n_Integer,x_List,opts___?OptionQ][{t_,s_}] :=
  BezierSurface[n,n,x,opts]

BezierSurface[n_Integer,m_Integer,x_List,opts___?OptionQ][{t_,s_}] :=
  Module[{l = Dimensions[x],
          ends = PadLeft[{},2,EndConditions /.
                                Flatten[{opts,Options[Bezier]}]]},
    Bezier[m,Map[Bezier[n,#,EndConditions -> ends[[2]]][s]&,x],
           EndConditions -> ends[[1]]][t]]




ClearAll[SplineTable,SplineBasis,Spline]

Options[Spline] = {EndConditions -> None};

SplineTable[0,1] := 1
SplineTable[0,i_Integer] := 0

SplineTable[n_Integer,i_Integer] := SplineTable[n,i] =
  Expand[T/n SplineTable[n - 1,i] +
         (n + 1 - T)/n (SplineTable[n - 1,i - 1] /. T -> T - 1)]
         
SplineBasis[n_Integer][t_] :=
  WhichTable[i - 1 <= t <= i,
             SplineTable[n,i] /. T -> t,{i,n + 1},
             DefaultValue -> 0]
             
Spline[n_Integer,x_List,opts___?OptionQ][t_] :=
  Module[{l = Length[x],
          ends = EndConditions /. Flatten[{opts,Options[Spline]}]},
    If[l <= n,
       Message[Spline::pts,l,n + 1];
         HoldForm[Spline[n,x,opts][t]],
       Switch[ends,
         Open,
           Module[{c = Flatten[{1,Table[- SplineBasis[n][i],
                                    {i,2,n}]}] / SplineBasis[n][1]},
             Spline[n,Join[{c . Take[x,n]},
                           x[[Range[2,l - 1]]],
                           {Reverse[c] . Take[x,-n]}],
               Interpolating -> False,EndConditions -> None][t]],
         Closed,
           Spline[n,Join[x,x[[Range[2,n]]]],
             Interpolating -> False,EndConditions -> None][t],
         None,
           Module[{s = (l - n) t + 1},
             Sum[SplineBasis[n][s - i + n] x[[i]],{i,1,l}]]]]]
       
Spline::pts = "`1` control points; at least `2` are expected";




ClearAll[SplineSurface]

Options[SplineSurface] = {EndConditions -> None};

SplineSurface[n_Integer,x_List,opts___?OptionQ][{t_,s_}] :=
  SplineSurface[n,n,x,opts]
  
SplineSurface[n_Integer,m_Integer,x_List,opts___?OptionQ][{t_,s_}] :=
  Module[{l = Dimensions[x],
          ends = PadLeft[{},2,EndConditions /.
                                Flatten[{opts,Options[Spline]}]]},
    Spline[m,Map[Spline[n,#,EndConditions -> ends[[2]]][s]&,x],
           EndConditions -> ends[[1]]][t]]




ClearAll[NormalVector]

NormalVector[curve_][t_] := Rotate2D[XY][curve'[t]]

NormalVector[surf_][{t_,s_}] := 
  Cross[Derivative[1,0][surf][{t,s}],Derivative[0,1][surf][{t,s}]]
